start-testcase-DMM file addition
[csit.git] / bootstrap-verify-perf.sh
index 584dea6..667c1d0 100755 (executable)
@@ -1,5 +1,5 @@
 #!/bin/bash
-# Copyright (c) 2017 Cisco and/or its affiliates.
+# Copyright (c) 2018 Cisco and/or its affiliates.
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at:
@@ -12,7 +12,7 @@
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-set -x
+set -xo pipefail
 
 # Space separated list of available testbeds, described by topology files
 TOPOLOGIES="topologies/available/lf_testbed1.yaml \
@@ -25,12 +25,12 @@ SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
 RESERVATION_DIR="/tmp/reservation_dir"
 INSTALLATION_DIR="/tmp/install_dir"
 
-PYBOT_ARGS="-W 150 -L TRACE"
-
-JOB_ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
-LOG_ARCHIVE_ARTIFACTS=(output.xml)
-LOG_ARCHIVES_DIR="$WORKSPACE/archives"
-mkdir -p ${LOG_ARCHIVES_DIR}
+JOB_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
+LOG_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
+JOB_ARCHIVE_DIR="archive"
+LOG_ARCHIVE_DIR="$WORKSPACE/archives"
+mkdir -p ${JOB_ARCHIVE_DIR}
+mkdir -p ${LOG_ARCHIVE_DIR}
 
 # If we run this script from CSIT jobs we want to use stable vpp version
 if [[ ${JOB_NAME} == csit-* ]] ;
@@ -63,7 +63,7 @@ then
         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
     fi
 
-    cd ..
+    cd ${SCRIPT_DIR}
 
 # If we run this script from vpp project we want to use local build
 elif [[ ${JOB_NAME} == vpp-* ]] ;
@@ -122,9 +122,8 @@ function cancel_all {
 # packages
 trap "cancel_all ${WORKING_TOPOLOGY}" EXIT
 
-python ${SCRIPT_DIR}/resources/tools/scripts/topo_installation.py -t ${WORKING_TOPOLOGY} \
-                                                       -d ${INSTALLATION_DIR} \
-                                                       -p ${VPP_DEBS}
+python ${SCRIPT_DIR}/resources/tools/scripts/topo_installation.py \
+    -t ${WORKING_TOPOLOGY} -d ${INSTALLATION_DIR} -p ${VPP_DEBS}
 if [ $? -eq 0 ]; then
     echo "VPP Installed on hosts from: ${WORKING_TOPOLOGY}"
 else
@@ -132,255 +131,156 @@ else
     exit 1
 fi
 
+# Based on job we will identify DUT
+if [[ ${JOB_NAME} == *hc2vpp* ]] ;
+then
+    DUT="hc2vpp"
+elif [[ ${JOB_NAME} == *vpp* ]] ;
+then
+    DUT="vpp"
+elif [[ ${JOB_NAME} == *ligato* ]] ;
+then
+    DUT="kubernetes"
+elif [[ ${JOB_NAME} == *dpdk* ]] ;
+then
+    DUT="dpdk"
+else
+    echo "Unable to identify dut type based on JOB_NAME variable: ${JOB_NAME}"
+    exit 1
+fi
+
+PYBOT_ARGS="--consolewidth 120 --loglevel TRACE --variable TOPOLOGY_PATH:${WORKING_TOPOLOGY} --suite tests.${DUT}.perf"
+
 case "$TEST_TAG" in
-    # run specific performance tests based on jenkins job type variable
+    # select specific performance tests based on jenkins job type variable
     PERFTEST_DAILY )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x520-da2AND1t1cORndrdiscANDnic_intel-x520-da2AND2t2c \
-              --include ndrdiscAND1t1cANDipsecORndrdiscAND2t2cANDipsec \
-              tests/
-        RETURN_STATUS=$(echo $?)
-        for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
-            cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVES_DIR}/${i}.log
-        done
+        TAGS=('ndrdiscANDnic_intel-x520-da2AND1t1c'
+              'ndrdiscANDnic_intel-x520-da2AND2t2c'
+              'ndrpdrANDnic_intel-x520-da2AND1t1c'
+              'ndrpdrANDnic_intel-x520-da2AND2t2c'
+              'ndrdiscAND1t1cANDipsec'
+              'ndrdiscAND2t2cANDipsec')
         ;;
     PERFTEST_SEMI_WEEKLY )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x710AND1t1cORndrdiscANDnic_intel-x710AND2t2cORndrdiscANDnic_intel-xl710AND1t1cORndrdiscANDnic_intel-xl710AND2t2c \
-              tests/
-        RETURN_STATUS=$(echo $?)
-        for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
-            cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVES_DIR}/${i}.log
-        done
+        TAGS=('ndrdiscANDnic_intel-x710AND1t1c'
+              'ndrdiscANDnic_intel-x710AND2t2c'
+              'ndrdiscANDnic_intel-xl710AND1t1c'
+              'ndrdiscANDnic_intel-xl710AND2t2c')
+        ;;
+    PERFTEST_MRR_DAILY )
+       TAGS=('mrrAND64bAND1t1c'
+             'mrrAND64bAND2t2c'
+             'mrrAND64bAND4t4c'
+             'mrrAND78bAND1t1c'
+             'mrrAND78bAND2t2c'
+             'mrrAND78bAND4t4c'
+             'mrrANDimixAND1t1cANDvhost'
+             'mrrANDimixAND2t2cANDvhost'
+             'mrrANDimixAND4t4cANDvhost'
+             'mrrANDimixAND1t1cANDmemif'
+             'mrrANDimixAND2t2cANDmemif'
+             'mrrANDimixAND4t4cANDmemif')
         ;;
     VERIFY-PERF-NDRDISC )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscAND1t1cORndrdiscAND2t2c \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('ndrdiscAND1t1c'
+              'ndrdiscAND2t2c')
         ;;
     VERIFY-PERF-PDRDISC )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include pdrdiscAND1t1cORpdrdiscAND2t2c \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrdiscAND1t1c'
+              'pdrdiscAND2t2c')
         ;;
     VERIFY-PERF-MRR )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include mrrAND1t1cORmrrAND2t2c \
-              tests/
-        RETURN_STATUS=$(echo $?)
-        ;;
-    PERFTEST_MRR_DAILY )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include mrrAND64bAND1t1c \
-              --include mrrAND64bAND2t2c \
-              --include mrrAND64bAND4t4c \
-              --include mrrAND78bAND1t1c \
-              --include mrrAND78bAND2t2c \
-              --include mrrAND78bAND4t4c \
-              tests/
-        RETURN_STATUS=$(echo $?)
-        for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
-            cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVES_DIR}/${i}.log
-        done
+        TAGS=('mrrAND1t1c'
+              'mrrAND2t2c')
         ;;
     VERIFY-PERF-IP4 )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip4baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('mrrANDnic_intel-x520-da2AND1t1cANDip4base'
+              'mrrANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m')
         ;;
     VERIFY-PERF-IP6 )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip6baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('mrrANDnic_intel-x520-da2AND1t1cANDip6base'
+              'mrrANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m')
         ;;
     VERIFY-PERF-L2 )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x520-da2AND1t1cANDl2xcbaseORndrdiscANDnic_intel-x520-da2AND1t1cANDl2bdbase \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('mrrANDnic_intel-x520-da2AND1t1cANDl2xcbase'
+              'mrrANDnic_intel-x520-da2AND1t1cANDl2bdbase')
         ;;
     VERIFY-PERF-LISP )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x520-da2AND1t1cANDlisp \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrchkANDnic_intel-x520-da2AND1t1cANDlisp')
         ;;
     VERIFY-PERF-VXLAN )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvxlan \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrchkANDnic_intel-x520-da2AND1t1cANDvxlan')
         ;;
     VERIFY-PERF-VHOST )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrdiscANDnic_intel-x520-da2AND1t1cANDvhost')
         ;;
     VERIFY-PERF-MEMIF )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include ndrdiscANDnic_intel-x520-da2AND1t1cANDmemif \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrdiscANDnic_intel-x520-da2AND1t1cANDmemif'
+              'pdrdiscANDnic_intel-x520-da2AND2t2cANDmemif'
+              'mrrANDnic_intel-x520-da2AND1t1cANDmemif'
+              'mrrANDnic_intel-x520-da2AND2t2cANDmemif')
         ;;
     VERIFY-PERF-IPSECHW )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf.crypto" \
-              --include ndrdiscANDnic_intel-xl710AND1t1cANDipsechw \
-              --include ndrdiscANDnic_intel-xl710AND2t2cANDipsechw \
-              tests/
+        TAGS=('pdrdiscANDnic_intel-xl710AND1t1cANDipsechw'
+              'pdrdiscANDnic_intel-xl710AND2t2cANDipsechw'
+              'mrrANDnic_intel-xl710AND1t1cANDipsechw'
+              'mrrANDnic_intel-xl710AND2t2cANDipsechw')
         ;;
     VPP-VERIFY-PERF-IP4 )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include mrrANDnic_intel-x520-da2AND1t1cANDip4baseORmrrANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('mrrANDnic_intel-x520-da2AND1t1cANDip4base'
+              'mrrANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m')
         ;;
     VPP-VERIFY-PERF-IP6 )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include mrrANDnic_intel-x520-da2AND1t1cANDip6baseORmrrANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('mrrANDnic_intel-x520-da2AND1t1cANDip6base'
+              'mrrANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m')
         ;;
     VPP-VERIFY-PERF-L2 )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include mrrANDnic_intel-x520-da2AND1t1cANDl2xcbaseORmrrANDnic_intel-x520-da2AND1t1cANDl2bdbase \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('mrrANDnic_intel-x520-da2AND1t1cANDl2xcbase'
+              'mrrANDnic_intel-x520-da2AND1t1cANDl2bdbase')
         ;;
     VPP-VERIFY-PERF-LISP )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include pdrchkANDnic_intel-x520-da2AND1t1cANDlisp \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrchkANDnic_intel-x520-da2AND1t1cANDlisp')
         ;;
     VPP-VERIFY-PERF-VXLAN )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include pdrchkANDnic_intel-x520-da2AND1t1cANDvxlan \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrchkANDnic_intel-x520-da2AND1t1cANDvxlan')
         ;;
     VPP-VERIFY-PERF-VHOST )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include pdrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrdiscANDnic_intel-x520-da2AND1t1cANDvhost')
         ;;
     VPP-VERIFY-PERF-MEMIF )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include pdrdiscANDnic_intel-x520-da2AND1t1cANDmemif \
-              --include pdrdiscANDnic_intel-x520-da2AND2t2cANDmemif \
-              --include mrrANDnic_intel-x520-da2AND1t1cANDmemif \
-              --include mrrANDnic_intel-x520-da2AND2t2cANDmemif \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrdiscANDnic_intel-x520-da2AND1t1cANDmemif'
+              'pdrdiscANDnic_intel-x520-da2AND2t2cANDmemif'
+              'mrrANDnic_intel-x520-da2AND1t1cANDmemif'
+              'mrrANDnic_intel-x520-da2AND2t2cANDmemif')
         ;;
     VPP-VERIFY-PERF-ACL )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --include pdrdiscANDnic_intel-x520-da2AND1t1cANDacl \
-              --include pdrdiscANDnic_intel-x520-da2AND2t2cANDacl \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrdiscANDnic_intel-x520-da2AND1t1cANDacl'
+              'pdrdiscANDnic_intel-x520-da2AND2t2cANDacl')
         ;;
     VPP-VERIFY-PERF-IPSECHW )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf.crypto" \
-              --include pdrdiscANDnic_intel-xl710AND1t1cANDipsechw \
-              --include pdrdiscANDnic_intel-xl710AND2t2cANDipsechw \
-              tests/
-        RETURN_STATUS=$(echo $?)
-        ;;
-    PERFTEST_LONG )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              --exclude SKIP_PATCH \
-              -i NDRPDRDISC \
-              tests/
-        RETURN_STATUS=$(echo $?)
-        ;;
-    PERFTEST_SHORT )
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              -i MRR \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('pdrdiscANDnic_intel-xl710AND1t1cANDipsechw'
+              'pdrdiscANDnic_intel-xl710AND2t2cANDipsechw'
+              'mrrANDnic_intel-xl710AND1t1cANDipsechw'
+              'mrrANDnic_intel-xl710AND2t2cANDipsechw')
         ;;
     * )
-        # run full performance test suite and exit on fail
-        pybot ${PYBOT_ARGS} \
-              -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-              -s "tests.vpp.perf" \
-              tests/
-        RETURN_STATUS=$(echo $?)
+        TAGS=('perftest')
 esac
 
-# Pybot output post-processing
-echo Post-processing test data...
+# Catenate TAG selections by 'OR'
+printf -v INCLUDES " --include %s " "${TAGS[@]}"
 
-python ${SCRIPT_DIR}/resources/tools/scripts/robot_output_parser.py \
-       -i ${SCRIPT_DIR}/output.xml \
-       -o ${SCRIPT_DIR}/output_perf_data.xml \
-       -v ${VPP_STABLE_VER}
-if [ ! $? -eq 0 ]; then
-    echo "Parsing ${SCRIPT_DIR}/output.xml failed"
-fi
+# Execute the test
+pybot ${PYBOT_ARGS}${INCLUDES} tests/
+RETURN_STATUS=$(echo $?)
 
-# Archive artifacts
-mkdir -p archive
+# Archive JOB artifacts in jenkins
 for i in ${JOB_ARCHIVE_ARTIFACTS[@]}; do
-    cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
+    cp $( readlink -f ${i} | tr '\n' ' ' ) ${JOB_ARCHIVE_DIR}/
+done
+# Archive JOB artifacts to logs.fd.io
+for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
+    cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVE_DIR}/
 done
 
-echo Post-processing finished.
-
-exit ${RETURN_STATUS}
+exit ${RETURN_STATUS}
\ No newline at end of file